#lang racket

;;; mfcalc4.rkt [jpr, cours Scheme L3-INFO 2007-2008]
;;; La version finale avec affectation et variables. Conditionnelle sans conflit.
;;; Les variables sont stockees avec leurs valeurs dans une table de hash-code.

(require "mfcalc-lexer.rkt")   ; qu'il faudra retoucher un peu pour cet exo 3.2 !!!!!!!!!!
(require parser-tools/yacc)

(printf "Generation du mfcalc parser complet. Aucun conflit.
Utilisez des variables, ainsi que les fonctions exp et log :\n")

; On maintient les valeurs des variables dans une table de hash-code, plus efficace qu'une liste...

(define vars (make-hash))

; Definition du parser

(define parse
  (parser

   (start S)                             ; l'axiome de depart
   (end SEMICOLON)                       ; fin d'une analyse sur point-virgule
   (tokens value-tokens op-tokens)
   (error (lambda (a b c) (printf "Parsing error with token ~a\n" b)))

   (precs (nonassoc LOWER_THAN_ELSE)
          (nonassoc ELSE)
          (nonassoc < > <= >= == !=)
          (right =)
          (left - +)
          (left * /)
          (left NEG)
          (right ^))
   
   (grammar
    
    (S     [() 'eof]
           [(expr) $1])
    
    (expr [(NUM) $1]
          [(BOOL) (eq? $1 'true)]
          [(VAR) (hash-ref vars $1 (lambda () 0))]           ; consultation d'une valeur de variable
          [(VAR = expr) (begin (hash-set! vars $1 $3) $3)]   ; modification de la valeur d'une variable
          [(FNCT LPAR expr RPAR) ((eval $1) $3)]                   ; appel de fonction
          [(expr + expr) (+ $1 $3)]
          [(expr - expr) (- $1 $3)]
          [(expr * expr) (* $1 $3)]
          [(expr / expr) (/ $1 $3)]
          [(- expr) (prec NEG) (- $2)]
          [(expr ^ expr) (expt $1 $3)]
          [(expr > expr) (> $1 $3)]
          [(expr >= expr) (>= $1 $3)]
          [(expr < expr) (< $1 $3)]
          [(expr <= expr) (<= $1 $3)]
          [(expr == expr) (equal? $1 $3)]
          [(expr != expr) (not (equal? $1 $3))]
          [(LPAR expr RPAR) $2]
          [(IF expr THEN expr ELSE expr) (if $2 $4 $6)]
          [(IF expr THEN expr) (prec LOWER_THAN_ELSE) (if $2 $4 (void))]))))

(define lex (lambda () (get-lexeme (current-input-port))))

(define (parse-one-expr) 
  (printf "? ")
  (let ((result (parse lex)))
    (when (not (eq? result 'eof))
        (begin (printf "==> ~a\n" result) 
               (parse-one-expr)))))

(parse-one-expr)


